<?php

namespace Drupal\group_taxonomy;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Access\AccessResultAllowed;
use Drupal\node\Plugin\views\filter\Access;
use Drupal\taxonomy\VocabularyListBuilder as VocabularyListBuilderBase;

/**
 * Class VocabularyListBuilder.
 *
 * @package Drupal\group_taxonomy
 */
class VocabularyListBuilder extends VocabularyListBuilderBase {

  /**
   * @return \Drupal\Core\Entity\EntityInterface[]
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   */
  public function load() {
    $entities = parent::load();
    $taxonomies = [];
    // Remove vocabularies the current user doesn't have any access for.
    foreach ($entities as $id => $entity) {
      $account = \Drupal::currentUser();
      $access = \Drupal::service('group_taxonomy.taxonomy')->taxonomyVocabularyAccess('view', $entity, $account);
      if ($access instanceof AccessResultAllowed) {
        $taxonomies[$id] = $entity;
      }
    }

    return $taxonomies;
  }

}
